// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from weight_scale_interfaces:msg/Weight.idl
// generated code does not contain a copyright notice
#include "weight_scale_interfaces/msg/detail/weight__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `unit`
#include "rosidl_runtime_c/string_functions.h"

bool
weight_scale_interfaces__msg__Weight__init(weight_scale_interfaces__msg__Weight * msg)
{
  if (!msg) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    weight_scale_interfaces__msg__Weight__fini(msg);
    return false;
  }
  // stable
  // overload
  // weight
  // unit
  if (!rosidl_runtime_c__String__init(&msg->unit)) {
    weight_scale_interfaces__msg__Weight__fini(msg);
    return false;
  }
  return true;
}

void
weight_scale_interfaces__msg__Weight__fini(weight_scale_interfaces__msg__Weight * msg)
{
  if (!msg) {
    return;
  }
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // stable
  // overload
  // weight
  // unit
  rosidl_runtime_c__String__fini(&msg->unit);
}

bool
weight_scale_interfaces__msg__Weight__are_equal(const weight_scale_interfaces__msg__Weight * lhs, const weight_scale_interfaces__msg__Weight * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // stable
  if (lhs->stable != rhs->stable) {
    return false;
  }
  // overload
  if (lhs->overload != rhs->overload) {
    return false;
  }
  // weight
  if (lhs->weight != rhs->weight) {
    return false;
  }
  // unit
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->unit), &(rhs->unit)))
  {
    return false;
  }
  return true;
}

bool
weight_scale_interfaces__msg__Weight__copy(
  const weight_scale_interfaces__msg__Weight * input,
  weight_scale_interfaces__msg__Weight * output)
{
  if (!input || !output) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // stable
  output->stable = input->stable;
  // overload
  output->overload = input->overload;
  // weight
  output->weight = input->weight;
  // unit
  if (!rosidl_runtime_c__String__copy(
      &(input->unit), &(output->unit)))
  {
    return false;
  }
  return true;
}

weight_scale_interfaces__msg__Weight *
weight_scale_interfaces__msg__Weight__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  weight_scale_interfaces__msg__Weight * msg = (weight_scale_interfaces__msg__Weight *)allocator.allocate(sizeof(weight_scale_interfaces__msg__Weight), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(weight_scale_interfaces__msg__Weight));
  bool success = weight_scale_interfaces__msg__Weight__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
weight_scale_interfaces__msg__Weight__destroy(weight_scale_interfaces__msg__Weight * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    weight_scale_interfaces__msg__Weight__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
weight_scale_interfaces__msg__Weight__Sequence__init(weight_scale_interfaces__msg__Weight__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  weight_scale_interfaces__msg__Weight * data = NULL;

  if (size) {
    data = (weight_scale_interfaces__msg__Weight *)allocator.zero_allocate(size, sizeof(weight_scale_interfaces__msg__Weight), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = weight_scale_interfaces__msg__Weight__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        weight_scale_interfaces__msg__Weight__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
weight_scale_interfaces__msg__Weight__Sequence__fini(weight_scale_interfaces__msg__Weight__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      weight_scale_interfaces__msg__Weight__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

weight_scale_interfaces__msg__Weight__Sequence *
weight_scale_interfaces__msg__Weight__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  weight_scale_interfaces__msg__Weight__Sequence * array = (weight_scale_interfaces__msg__Weight__Sequence *)allocator.allocate(sizeof(weight_scale_interfaces__msg__Weight__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = weight_scale_interfaces__msg__Weight__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
weight_scale_interfaces__msg__Weight__Sequence__destroy(weight_scale_interfaces__msg__Weight__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    weight_scale_interfaces__msg__Weight__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
weight_scale_interfaces__msg__Weight__Sequence__are_equal(const weight_scale_interfaces__msg__Weight__Sequence * lhs, const weight_scale_interfaces__msg__Weight__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!weight_scale_interfaces__msg__Weight__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
weight_scale_interfaces__msg__Weight__Sequence__copy(
  const weight_scale_interfaces__msg__Weight__Sequence * input,
  weight_scale_interfaces__msg__Weight__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(weight_scale_interfaces__msg__Weight);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    weight_scale_interfaces__msg__Weight * data =
      (weight_scale_interfaces__msg__Weight *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!weight_scale_interfaces__msg__Weight__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          weight_scale_interfaces__msg__Weight__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!weight_scale_interfaces__msg__Weight__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
